package io.github.introml.activityrecognition;

import android.Manifest;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Build;
import android.os.Bundle;

import android.provider.Settings;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;

import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Locale;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;

import com.ellipticlabs.sensor.ELSensorEvent;
import com.ellipticlabs.sensor.ELSensorManager;
import com.ellipticlabs.sensor.ISensor;
import com.ellipticlabs.sensor.ISensorListener;

public class MainActivity extends AppCompatActivity implements SensorEventListener{


    private static Float x;
    private static Float y;
    private static Float z;
    private static Float rx;
    private static Float ry;
    private static Float rz;
    private static Float us;

    private RelativeLayout box;

    private float[] results;
    private float[] current_results;
    private TensorFlowClassifier classifier;

    private String sensorName;
    private QueueArray_2D data;
    private State_Machine state_machine;

    private static ELSensorManager sensorManager;
    public ISensor sensor;
    public ISensorListener sensorListener = (ELSensorEvent event) -> {
        sensorName = event.sensor.getName();
//        Log.d("SensorChangend",sensorName + ": Vals: "+ event.values[0] + ";");
        if(event.sensor.getName().equals("Elliptic Proximity")){
            us = (event.values[0] == (float) 5.0) ? (float)0.0 : (float)1.0 ;
            Log.d("ISensorChangend",sensorName + ": Vals: "+ event.values[0] + ";");
        }else{
            Log.d("ISensorChangend",sensorName + ": Vals: "+ event.values[0] + ";");

        }
//        if(us == 1.0){ state_machine.state = 1;}
    };


//        data.add(x, y, z, rx, rz, ry, us);
//        activityPrediction();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        x = new Float(0.0);
        y = new Float(0.0);
        z = new Float(0.0);
        rx = new Float(0.0);
        ry = new Float(0.0);
        rz = new Float(0.0);
        us = new Float(0.0);

        box = (RelativeLayout) findViewById(R.id.layout);
        data = new QueueArray_2D(7,40);
        state_machine = new State_Machine();
        Log.d("External permission:", String.valueOf( checkPermissionForReadExtertalStorage() ));
        ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.READ_EXTERNAL_STORAGE}, 3);
        classifier = new TensorFlowClassifier(getApplicationContext());
        Log.d("write perm:", String.valueOf(Settings.System.canWrite(getApplicationContext())));
        Intent intent = new Intent(android.provider.Settings.ACTION_MANAGE_WRITE_SETTINGS);
        Log.d("write perm2:", String.valueOf(Settings.System.canWrite(getApplicationContext())));
        sensorManager = ELSensorManager.getInstance(getApplicationContext());
        List<ISensor> sensors = sensorManager.getSensorsContainingName("Elliptic Proximity");
        for(ISensor s : sensors) {
            if(s.getName().equals("Elliptic Proximity")){
                sensor = s;
                break;
            }
        }
            Timer timer = new Timer();
        timer.scheduleAtFixedRate(new TimerTask() {
            @Override
            public void run() {
                if (results == null || results.length == 0) {
                    return;
                }

                current_results = results; //Added to make sure results doesn't change during check
                float max = -1;
                int idx = -1;
                for (int i = 0; i < current_results.length; i++) {
                    if (current_results[i] > max) {
                        idx = i;
                        max = current_results[i];
                    }
                }
                state_machine.new_elem(idx);

                if(idx== 0){
                    box.setBackgroundColor(Color.WHITE);
                }
                else if(idx== 2){
                    box.setBackgroundColor(Color.GREEN);
                }
                else if(idx== 3){
                    box.setBackgroundColor(Color.RED);
                }
                else{
                    box.setBackgroundColor(Color.BLACK);
                }


            }
        }, 200, 100);
    }



    protected void onPause() {
        getSensorManager().unregisterListener(this);
        sensorManager.unregisterSensor(sensor, sensorListener);
        super.onPause();
    }

    protected void onResume() {
        super.onResume();
        getSensorManager().registerListener(this, getSensorManager().getDefaultSensor(Sensor.TYPE_ACCELEROMETER), SensorManager.SENSOR_DELAY_GAME);
        getSensorManager().registerListener(this, getSensorManager().getDefaultSensor(Sensor.TYPE_GYROSCOPE), SensorManager.SENSOR_DELAY_GAME);
        sensorManager.registerSensor(sensor,sensorListener);
    }

    @Override
    public void onSensorChanged(SensorEvent event) {
        sensorName = event.sensor.getName();
//        Log.d("SensorChangend",sensorName + ": X: " + event.values[0] + "; Y: " + event.values[1] + "; Z: " + event.values[2] + ";");

        if (sensorName.equals("BMI160 accelerometer")) {
            x = event.values[0];
            y = event.values[1];
            z = event.values[2];
        }
        else if (sensorName.equals("BMI160 gyroscope")){
            rx = event.values[0];
            ry = event.values[1];
            rz = event.values[2];
        }
        else{
            return;
        }
        data.add(x, y, z, rx, rz, ry, us);

        activityPrediction();
    }

    @Override
    public void onAccuracyChanged(Sensor sensor, int i) {

    }

    private void activityPrediction() {
        results = classifier.predictProbabilities(data.get_array());
    }

    private SensorManager getSensorManager() {
        return (SensorManager) getSystemService(SENSOR_SERVICE);
    }


    public class QueueArray{
        private int size;
        public float[] array;

        public QueueArray(int size){
            this.size = size;
            array = new float[size];
        }
        public void add(float x, float y, float z, float rx, float ry, float rz){
            for (int i  = array.length-1; i>=6; i--){
                array[i] = array[i-6];
            }
            array[0] = x; array[1] = y; array[2] = z; array[3] = rx; array[4] = ry; array[5] = rz;
        }
        public float[] get_array(){
            return array;
        }
    }
    public class QueueArray_2D{
        private int size;
        private int dim;
        private float[][] array;

        public QueueArray_2D(int dimensions,int size){
            this.size = size;
            this.dim = dimensions;
            array = new float[size][dimensions];
        }
        public void add(float x, float y, float z, float rx, float ry, float rz, float us){
            for (int i  = array.length-1; i>0; i--){
                array[i] = array[i-1];
            }
            array[0][0] = x; array[0][1] = y; array[0][2] = z; array[0][3] = rx; array[0][4] = ry; array[0][5] = rz; array[0][6] = us;

        }

        public float[] get_array(){ //If input in manually flattened
            float [] ret_array = new float[dim*size];
            for (int i = 0; i< dim*size; i++){
                ret_array[i] = array[i/dim][i%dim];
            }
            return ret_array;
        }

//        public float[] get_array(){  //If Flatten() is used
//                float [] ret_array = new float[dim*size];
//                for (int i = 0; i< dim; i++){
//                    for (int j = 0; j < size; j++)
//                    ret_array[i*j + j] = array[j][i];
//                }
//                return ret_array;
//            }



}

    public class State_Machine{
        public int state;

        State_Machine(){
            state = 0;
        }

        public void new_elem(int elem) {

            if (elem != state){
                if (elem == 2 && state ==0){
                    state = elem;
                }

                else if (elem ==3 && state ==1){
                    state = elem;
                }

                else if (state ==2){
                    state = 1;
                }

                else if (state ==3){
                    state = 0;
                }

            }
        }
    }



    public boolean checkPermissionForReadExtertalStorage() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            int result = getApplicationContext().checkSelfPermission(Manifest.permission.READ_EXTERNAL_STORAGE);
            return result == PackageManager.PERMISSION_GRANTED;
        }
        return false;
    }

}

