package io.github.introml.activityrecognition;

import android.content.Context;

import org.tensorflow.contrib.android.TensorFlowInferenceInterface;


public class TensorFlowClassifier {
    static {
        System.loadLibrary("tensorflow_inference");
    }

    private TensorFlowInferenceInterface inferenceInterface;
    private static final String MODEL_FILE = "file:///android_asset/model_in280_out4_us_needStateMachine.pb";
//    private static final String MODEL_FILE = "file:///android_asset/fix_weight_140.pb";
//private static final String MODEL_FILE = "file:///android_asset/hypermodel_6_GRU_gen.pb";


    private static final String INPUT_NODE = "graph_input_input";
    private static final String[] OUTPUT_NODES = {"graph_output/Softmax"};
    private static final String OUTPUT_NODE = "graph_output/Softmax";
    private static final long[] INPUT_SIZE = {1,280};
//    private static final long[] INPUT_SIZE = {1,6,1};
    private static final int OUTPUT_SIZE = 4;

    public TensorFlowClassifier(final Context context) {
        inferenceInterface = new TensorFlowInferenceInterface(context.getAssets(), MODEL_FILE);
    }

    public float[] predictProbabilities(float[] data) {
        float[] result = new float[OUTPUT_SIZE];
        inferenceInterface.feed(INPUT_NODE, data, INPUT_SIZE);
        inferenceInterface.run(OUTPUT_NODES);
        inferenceInterface.fetch(OUTPUT_NODE, result);


        return result;
    }
}
