import sys
sys.path.append('..\\')
from keras.models import Sequential
from keras.layers import Dense, Dropout, LSTM, Flatten, GRU
from keras.utils import plot_model
from keras.callbacks import TensorBoard
from keras import regularizers
from ExternalStudents.keras_utils.data_io import MatDataGenerator
from ExternalStudents.keras_utils.graph_io import save_optimized_graph



window_size = 20
mat_folder = r'C:\temp\EirikLid\f2n'
seed = 0
prefetch_size = 1024
batch_size = 32
_FAR_LABEL = 'Far'
_NEAR_LABEL = 'Near'
_FAR2NEAR_LABEL = 'Far2Near'
_NEAR2FAR_LABEL = 'Near2Far'


train_datagen_config = {
    'window_size' : window_size,
    'mat_folder' : mat_folder,
    'seed' : seed,
    'prefetch_size' : prefetch_size,
    'class_labels' : [_FAR_LABEL, _NEAR_LABEL , _FAR2NEAR_LABEL, _NEAR2FAR_LABEL],
    'class_weight' : [19,19,1,1],
    # 'data_stride': 4,
    'batch_size': batch_size
}



data_generator_obj = MatDataGenerator.MatDataGenerator(**train_datagen_config,flatten=False)

input_node_name = 'graph_input'
output_node_name = 'graph_output'

# def build_dnn_model():
#     model = Sequential()
#     #model.add(Dropout(0.2, input_shape=(data_generator_obj.input_shape,), name=input_node_name))
#     #model.add(LSTM(100, input_shape=(data_generator_obj.input_shape), name=input_node_name ))
#     #model.add(Flatten())
#     #model.add(Dropout(0.25))
#     model.add(Dense(64,
#                     activation='relu',input_shape=(data_generator_obj.input_shape,), name=input_node_name,
#                     kernel_regularizer=regularizers.l2(0.001),
#                     activity_regularizer=regularizers.l1(0.001)))
#
#    #model.add(Dropout(0.5))
#
#
#     model.add(Dense(32,
#                     activation='relu',kernel_regularizer=regularizers.l2(0.001),
#                     activity_regularizer=regularizers.l1(0.001)))
#
#     #model.add(Dropout(0.5))
#     model.add(Dense(16,
#                     activation='relu',
#                     kernel_regularizer=regularizers.l2(0.001),
#                     activity_regularizer=regularizers.l1(0.001)
#                     ))
#
#     #model.add(Dropout(0.5))
#     model.add(Dense(2, activation='softmax', name=output_node_name))
#
#     model.compile(loss='categorical_crossentropy',
#                   optimizer='Nadam',
#                   metrics=['accuracy'])
#
#     return model
#

def build_dnn_model():
    model = Sequential()
    model.add(Dropout(0.2, input_shape=data_generator_obj.input_shape, name=input_node_name))
    # model.add(GRU(100,return_sequences=True, input_shape=data_generator_obj.input_shape, name=input_node_name, dropout=0.5))
    model.add(Flatten()) #input_shape=data_generator_obj.input_shape, name=input_node_name))
    # model.add(Dropout(0.25))
    # model.add(Dense(128,
    #                 activation='relu'))
    #
    # model.add(Dropout(0.5))
    model.add(Dense(64,
                    activation='relu'))

    model.add(Dropout(0.5))

    model.add(Dense(32,
                    activation='relu'))

    model.add(Dropout(0.5))
    model.add(Dense(16,
                    activation='relu'))

    # model.add(Dropout(0.5))
    model.add(Dense(2, activation='softmax', name=output_node_name))

    model.compile(loss='categorical_crossentropy',
                  optimizer='nadam',
                  metrics=['accuracy'])

    return model


model = build_dnn_model()
model.summary()

plot_model(model, to_file='IMU_model.png', show_shapes=True)
#
# window_size = 60
# test_folder = r'C:\temp\EirikLid\testfiles'
# seed = 0
# prefetch_size = 1024
# _FAR_LABEL = 'Far'
# _NEAR_LABEL = 'Near'
#

# test_datagen_config = {
#     'window_size' : window_size,
#     'mat_folder' : test_folder,
#     'seed' : seed,
#     'prefetch_size' : prefetch_size,
#     'class_labels': [_FAR_LABEL, _NEAR_LABEL, _FAR2NEAR_LABEL, _NEAR2FAR_LABEL],
#     'class_weight': [19, 19, 1, 1]
#   }


# test_data_generator_obj = MatDataGenerator.MatDataGenerator(**test_datagen_config, shuffle= False)

train_stats = model.fit_generator(  generator=data_generator_obj.generator(),
                                    steps_per_epoch=5000,
                                    epochs=10,
                                    workers=16,
                                    #validation_data=test_data_generator_obj.generator(),
                                    #validation_steps=4000,
                                    verbose=1)


model.save(r'C:\temp\EirikLid\MLP_6_20_o2.h5')


plot_model(model, to_file='model.png', show_shapes=True)