from os.path import join, isdir, isfile
import scipy.io as sio
import glob



def get_recordings(mat_folder):

    mat_pattern = join(mat_folder, "*.mat")
    mat_files = glob.glob(mat_pattern)

    if len(mat_files) == 0:
        raise ValueError('Mat file folder {} does not contain any mat files'.format(mat_folder))

    return [sio.loadmat(mf, struct_as_record=False, squeeze_me=True) for mf in mat_files]