import numpy as np

def pred_array(prediction,offset,batch_void = 0):
    pred = [0]*offset

    for elem in prediction:
        pred.append( np.argmax(elem))
    pred.extend([0]*batch_void)
    return np.array(pred)

def pred_array_state_machine(prediction,offset,batch_void = 0):
    pred  = pred_array(prediction,offset,batch_void)
    prev = 0
    ret_array = np.zeros(len(pred))
    for i, elem in enumerate(pred):
        if elem == prev:
            ret_array[i] = elem
        else:
            if elem == 0 and prev == 3:
                ret_array[i] = elem
                prev = elem

            elif elem == 1 and prev == 2:
                ret_array[i] = elem
                prev = elem

            elif elem == 2 and prev == 0:
                ret_array[i] = elem
                prev = elem

            elif elem == 3 and prev == 1:
                ret_array[i] = elem
                prev = elem

            else:
                ret_array[i] = prev

    return ret_array

def pred_array_state_switch(prediction,offset,batch_void = 0):
    pred  = pred_array(prediction,offset,batch_void)
    state = 0
    ret_array = np.zeros(len(pred))
    for i, elem in enumerate(pred):
        if elem == state:
            ret_array[i] = elem
        else:
            if elem == 2 and state == 0:
                ret_array[i] = elem
                state = elem
            elif elem == 3 and state == 1:
                ret_array[i] = elem
                state = elem
            elif state == 2:
                ret_array[i] = 1
                state = 1

            elif state == 3:
                ret_array[i] = 0
                state = 0

            else:
                ret_array[i] = state

    return ret_array


# a = np.random.randint(0, 5, size=(5, 4))
#
# b = pred_array_state_machine(a, 4)
#
# print(b)


