import numpy as np
from ExternalStudents.file_utils import make_consecutive_batch, make_pred_array, get_rec
from sklearn.metrics import confusion_matrix
from keras.models import load_model



def recall( cm):
    rec = np.zeros(cm.shape[0])
    for i in range(cm.shape[0]):
        rec[i] = cm[i][i]/(cm[i].sum())

    return rec

def precision( cm):
    pre = np.zeros(cm.shape[0])

    for i in range(cm.shape[0]):
        pre[i] = cm[i][i]/(cm[:,i].sum())

    return pre

def accuracy(cm):
    return (cm.diagonal().sum())/(cm.sum())

def normalized(cm):
    return cm/cm.sum()

# from sklearn.metrics import confusion_matrix
# import sklearn.metrics
# # y_true, y_pred = [0,2,3,3,3,1,1,2,2,3], [3,1,1,3,3,1,1,2,0,0]
# y_true, y_pred = np.random.randint(3,size=40), np.random.randint(3,size=40)
# cm = confusion_matrix(y_true,y_pred, labels=[0,1,2])
# print(precision(cm))
# #
# # cm = confusion_matrix([0,1,1,1,0,1,1,0,1,1], [1,1,1,1,1,1,1,1,1,1], labels=[0,1])
# pre_dict = precision(cm)
# rec_dict = recall(cm)
# acc_1 = accuracy(cm)
# met_acc = sklearn.metrics.accuracy_score(y_true,y_pred)
# met_pre =  sklearn.metrics.precision_score(y_true,y_pred, average='macro')
# met_rec = sklearn.metrics.recall_score(y_true,y_pred, average='macro')
#
# cm = np.array([  [4272,     98],
#         [   0,   3905]])
#
# tn, fp, fn, tp = cm.ravel()
# print(tn, fp, fn, tp)
#
# err = (fp + fn)/(fp + fn + tp + tn)
# acc = 1 - err
#
# fp_rate = fp/(fp + tn)
# tp_rate = tp/(fn + tp)
#
# pre = tp/(tp+fp)
# rec = tp_rate
#
# f1 = 2*(pre*rec)/(pre + rec)
#
# print("Error:", err)
# print("Accuracy:", acc)
# print("False positive rate:", fp_rate)
# print("True positive rate:", tp_rate)
# print("Precision:",pre)
# print("Recall:",rec)
# print("F1:",f1)
#
# print("\n Flip!")
# cm = np.flip(cm,0)
# cm = np.flip(cm,1)
# tn, fp, fn, tp = cm.ravel()
# print(tn, fp, fn, tp)
#
# err = (fp + fn)/(fp + fn + tp + tn)
# acc = 1 - err
#
# fp_rate = fp/(fp + tn)
# tp_rate = tp/(fn + tp)
#
# pre = tp/(tp+fp)
# rec = tp_rate
#
# f1 = 2*(pre*rec)/(pre + rec)
#
# print("Error:", err)
# print("Accuracy:", acc)
# print("False positive rate:", fp_rate)
# print("True positive rate:", tp_rate)
# print("Precision:",pre)
# print("Recall:",rec)
# print("F1:",f1)


def get_metric(model, data, window_size):
    conf = [[0, 0, 0, 0],
            [0, 0, 0, 0],
            [0, 0, 0, 0],
            [0, 0, 0, 0]]
    # conf = [[0, 0], [0, 0]]

    for test_seq in data:
        batch = make_consecutive_batch.make(test_seq['X'], window_size=window_size, num_features=7)
        prediction = model.predict_on_batch(batch)
        offset = test_seq['y'].shape[0] - len(prediction)
        pred = make_pred_array.pred_array(prediction, offset)

        cm = confusion_matrix(test_seq['y'], pred, labels=[0,1,2,3])
        # cm = confusion_matrix(np.where(test_seq['y'] == 1, 1, 0), np.where(pred == 1, 1, 0), labels=[0,1])
        # print(cm)
        conf += cm


    print("Test loss and metric:")
    # print(conf)
    acc = accuracy(conf)
    pre = precision(conf)
    rec = recall(conf)
    percent = 100*conf/conf.sum()
    print("Acc:", acc, "Precision:", pre, "Recall:", rec)
    print("Macro pre:", pre.mean(), "Macro rec", rec.mean())
    # tn, fp, fn, tp = conf.ravel()
    # print(tn, fp, fn, tp)
    #
    # err = (fp + fn)/(fp + fn + tp + tn)
    # acc = 1 - err
    #
    # fp_rate = fp/(fp + tn)
    # tp_rate = tp/(fn + tp)
    #
    # pre = tp/(tp+fp)
    # rec = tp_rate
    #
    # f1 = 2*(pre*rec)/(pre + rec)
    #
    # print("Error:", err)
    # print("Accuracy:", acc)
    # print("False positive rate:", fp_rate)
    # print("True positive rate:", tp_rate)
    # print("Precision:",pre)
    # print("Recall:",rec)
    # print("F1:",f1)




# model = load_model(r'C:\temp\EirikLid\GodeModeller\us_MLP_280_braMenTrengerStateMachine.h5')
# model = load_model(r'C:\temp\EirikLid\GodeModeller\hypermodel_7_20_gen.h5')
#
# model = load_model(r'C:\temp\EirikLid\hypermodel_7_20_us_gen.h5')
# model = load_model(r'C:\temp\EirikLid\hypermodel_6_20_o2.h5')
# model = load_model(r'C:\temp\EirikLid\hypermodel_6_20_o4_gen.h5')
# model = load_model(r'C:\temp\EirikLid\hypermodel_6_GRU_gen.h5')

# model.summary()
# files = get_rec.get_recordings(mat_folder =r'C:\temp\EirikLid\us_data_new')

# get_metric(model,files,20)


# cm = np.array([  [4272,     98],
#         [   0,   3905]])

cm = np.array([  [165592,     17303],
        [   3965,   144836]])


percent = 100*cm/cm.sum()
print(percent)


