import sys
sys.path.append('..\\')
from keras.models import load_model

import numpy as np

from ExternalStudents.plot import plot_data
from ExternalStudents.file_utils import get_rec, make_consecutive_batch, make_pred_array
from ExternalStudents.keras_utils.data_io import MatDataGenerator

from sklearn.metrics import confusion_matrix

model = load_model(r'C:\temp\EirikLid\hypermodel_6_20_o2.h5')

model.summary()


files = get_rec.get_recordings(r'C:\temp\EirikLid\data_test_fn')

window = 20
stride = 1


conf = [[0, 0], [0, 0]]

for file in files:

    batch = make_consecutive_batch.make(file['X'],window_size=window,num_features=6,stride=stride)
    prediction = model.predict_on_batch(batch)
    offset = file['y'][::stride].shape[0]- len(prediction)
    pred = make_pred_array.pred_array(prediction,offset)
    # plot_data.plot_data(file, pred,stride=stride, us=False, fn_convert=False)

    cm = confusion_matrix(file['y'], pred, labels=[0, 1])
    conf += cm

tn, fp, fn, tp = conf.ravel()
print(tn, fp, fn, tp)

err = (fp + fn)/(fp + fn + tp + tn)
acc = 1 - err

fp_rate = fp/(fp + tn)
tp_rate = tp/(fn + tp)

pre = tp/(tp+fp)
rec = tp_rate

f1 = 2*(pre*rec)/(pre + rec)

print("Error:", err)
print("Accuracy:", acc)
print("False positive rate:", fp_rate)
print("True positive rate:", tp_rate)
print("Precision:",pre)
print("Recall:",rec)
print("F1:",f1)






