import sys
sys.path.append('..\\')
from keras.models import Sequential
from keras.layers import Dense, Dropout, LSTM, Flatten, GRU
from keras.utils import plot_model
from keras.callbacks import TensorBoard
from keras import regularizers
from ExternalStudents.keras_utils.data_io import MatDataGenerator, SequentialDataGenerator
from ExternalStudents.keras_utils.graph_io import save_optimized_graph
from ExternalStudents.file_utils import get_rec, make_consecutive_batch

import numpy as np

# files = get_rec.get_recordings(r'C:\temp\EirikLid\f2n')

window_size = 40
mat_folder = r'C:\temp\EirikLid\us_data'
#mat_folder = r'C:\temp\EirikLid\f2n'
seed = 0
prefetch_size = 1024
batch_size = 100
_FAR_LABEL = 'Far'
_NEAR_LABEL = 'Near'
_FAR2NEAR_LABEL = 'Far2Near'
_NEAR2FAR_LABEL = 'Near2Far'


train_datagen_config = {
    'window_size' : window_size,
    'mat_folder' : mat_folder,
    'seed' : seed,
    'prefetch_size' : prefetch_size,
    'class_labels' : [_FAR_LABEL, _NEAR_LABEL, _FAR2NEAR_LABEL, _NEAR2FAR_LABEL],
    # 'class_labels': [_FAR_LABEL, _NEAR_LABEL],
    'batch_size': batch_size
}



data_generator_obj = SequentialDataGenerator.SequentialDataGenerator(**train_datagen_config,flatten=False)

input_node_name = 'graph_input'
output_node_name = 'graph_output'

def build_dnn_model():
    model = Sequential()
    # model.add(Dense(24, activation='relu',input_shape=(7,window_size,),  name=input_node_name))
    # model.add(Dropout(0.25))
    # model.add(Dense(48, activation='relu'))
    # # model.add(Dropout(0.2, input_shape=(6,window_size,) , batch_input_shape=((batch_size,6,window_size,)), name=input_node_name))
    # model.add(GRU(100,return_sequences=True, dropout=0.25, recurrent_dropout=0.1))
    # model.add(Flatten())
    model.add(Dropout(0.2,input_shape=(7,window_size,),  name=input_node_name))
    model.add(Dense(64,
                    activation='relu'))

    model.add(Dropout(0.5))

    model.add(Dense(32,
                    activation='relu'))

    model.add(Dropout(0.5))
    model.add(Dense(16,
                    activation='relu'))

    model.add(Dropout(0.5))
    model.add(Dense(4, activation='softmax'))
    model.add(LSTM(50, return_sequences=True))
    model.add(Flatten())
    model.add(Dense(32,
                    activation='relu'))

    model.add(Dropout(0.5))
    model.add(Dense(16,
                    activation='relu'))

    model.add(Dropout(0.5))
    model.add(Dense(4, activation='softmax', name=output_node_name))


    model.compile(loss='categorical_crossentropy',
                  optimizer='Nadam',
                  metrics=['accuracy'])

    return model


model = build_dnn_model()
model.summary()

train_stats = model.fit_generator(  generator=data_generator_obj.generator(),
                                    steps_per_epoch=5000,
                                    epochs=30,
                                    workers=16,
                                    #validation_data=test_data_generator_obj.generator(),
                                    #validation_steps=4000,
                                    verbose=2)
model.save(r'C:\temp\EirikLid\us_double.h5')
# X, Y = make_consecutive_batch.make_training_set(files)
#
# np.save("X",X)
# np.save("Y",Y)
#
# X_40 = make_consecutive_batch.make(X)
# np.save("X_40",X_40)
#Y = np.load("ExternalStudents/Y.npy")
#y = make_consecutive_batch.make_y(Y,4)
# np.save("y_split",y)

# X_40 = np.load("ExternalStudents/X_40.npy")
# X = np.load("ExternalStudents/X.npy")
# y = np.load("ExternalStudents/y.npy")
#
#
# for file in files:
#
#     train_stats = model.fit_on_( x=X, y = y,
#                                     steps_per_epoch=5000,
#                                     epochs=50,
#                                     #validation_data=test_data_generator_obj.generator(),
#                                     #validation_steps=4000,
#                                     verbose=1,
#                                     shuffle=False)
#
#
# model.save(r'C:\temp\EirikLid\GRU240.h5')
#
#
# plot_model(model, to_file='model.png', show_shapes=True)


